"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_compose_1 = require("graphql-compose");
var ObjectParser = /** @class */ (function () {
    function ObjectParser() {
    }
    ObjectParser.createTC = function (name, json, opts) {
        var _this = this;
        if (!json || typeof json !== 'object') {
            throw new Error('You provide empty object in second arg for `createTC` method.');
        }
        var sc = (opts === null || opts === void 0 ? void 0 : opts.schemaComposer) || graphql_compose_1.schemaComposer;
        var tc = sc.createObjectTC(name);
        Object.keys(json).forEach(function (fieldName) {
            var fieldConfig = _this.getFieldConfig(json[fieldName], { typeName: name, fieldName: fieldName });
            tc.setField(fieldName, fieldConfig);
        });
        return tc;
    };
    ObjectParser.getFieldConfig = function (value, opts) {
        var typeOf = typeof value;
        if (typeOf === 'number')
            return 'Float';
        if (typeOf === 'string')
            return 'String';
        if (typeOf === 'boolean')
            return 'Boolean';
        if (graphql_compose_1.isComposeOutputType(value)) {
            return value;
        }
        if (typeOf === 'object') {
            if (value === null)
                return 'JSON';
            if (Array.isArray(value)) {
                if (Array.isArray(value[0]))
                    return ['JSON'];
                var val = typeof value[0] === 'object' && value[0] !== null
                    ? Object.assign.apply(Object, __spreadArrays([{}], value)) : value[0];
                var args = opts && opts.typeName && opts.fieldName
                    ? {
                        typeName: opts.typeName,
                        fieldName: opts.fieldName,
                    }
                    : {};
                return [this.getFieldConfig(val, args)];
            }
            if (opts && opts.typeName && opts.fieldName) {
                return this.createTC(opts.typeName + "_" + graphql_compose_1.upperFirst(opts.fieldName), value);
            }
        }
        if (typeOf === 'function') {
            return value();
        }
        return 'JSON';
    };
    return ObjectParser;
}());
exports.default = ObjectParser;
