"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PeopleTC = void 0;
var node_fetch_1 = __importDefault(require("node-fetch"));
var index_1 = require("../index");
var Film_1 = require("./Film");
var restApiResponse = {
    name: 'Luke Skywalker',
    height: '172',
    mass: '77',
    hair_color: 'blond',
    skin_color: 'fair',
    eye_color: 'blue',
    birth_year: '19BBY',
    gender: 'male',
    films: [
        'https://swapi.co/api/films/2/',
        'https://swapi.co/api/films/6/',
        'https://swapi.co/api/films/3/',
    ],
};
exports.PeopleTC = index_1.composeWithJson('People', restApiResponse);
// //////////////
// RESOLVERS aka FieldConfig in GraphQL
// //////////////
exports.PeopleTC.addResolver({
    name: 'findById',
    type: exports.PeopleTC,
    args: {
        id: 'Int!',
    },
    resolve: function (rp) {
        return node_fetch_1.default("https://swapi.co/api/people/" + rp.args.id + "/").then(function (r) { return r.json(); });
    },
});
exports.PeopleTC.addResolver({
    name: 'findByUrl',
    type: exports.PeopleTC,
    args: {
        url: 'String!',
    },
    resolve: function (rp) { return node_fetch_1.default(rp.args.url).then(function (r) { return r.json(); }); },
});
exports.PeopleTC.addResolver({
    name: 'findByUrlList',
    type: [exports.PeopleTC],
    args: {
        urls: '[String]!',
    },
    resolve: function (rp) {
        return Promise.all(rp.args.urls.map(function (url) { return node_fetch_1.default(url).then(function (r) { return r.json(); }); }));
    },
});
// //////////////
// RELATIONS
// //////////////
exports.PeopleTC.addRelation('filmObjs', {
    resolver: function () { return Film_1.FilmTC.getResolver('findByUrlList'); },
    prepareArgs: {
        urls: function (source) { return source.films; },
    },
});
